%% CIS II Galen Calibration Pipeline - Apply Correction Function
% Repurposed from: Programming Assignment 2 - Problem 1; CIS 1, Fall 2019
% By Can Kocabalkanli and Nicolas Lamaison

function [p] = correctDistortion(q, qmax, qmin, S)
    %Scale q to box defined by qmin and qmax
    u = ScaleToBox(q, qmax, qmin);
    ux = u(1);
    uy = u(2);
    uz = u(3);
    
    ur = u(4);
    up = u(5);
    %Should we add u6?
    p = [0; 0; 0; 0; 0]; %and  6th here?
    o = 5;  %Order of Bernstein Polynomial
    
    %Calculate p as the Bernstein polynomials multiplied by the coefficient 
    %vectors summed over i,j,k
    for i = 1:(o+1)
        for j = 1:(o+1)
            for k = 1:(o+1)
                for l = 1:(o+1)
                    for m = 1:(o+1) %M and L might need to be before ijk
                            c = S(i+(o+1)*(j - 1)+((o+1)^2)*(k - 1), :); %THIS NEEDS TO BE MODIFIED FOR 5-DOF
                            p = p + (c*bern(o,(i-1),ux)*bern(o,(j-1),uy)*bern(o,(k-1),uz)*bern(o,(l-1),ur)*bern(o,(m-1),up))';
                    end
                end
            end
        end
    end
    %Re-Scale p
    p = (qmax-qmin).*p + qmin;
end