%%Can Kocabalkanli and Nicolas Lamaison CIS 2, Spring 2020
%% Converts transformation matrices stored as 3D arrays into concatenated 2d arrays
function [C_data_2D, C_exp_2D, d] = mat2to3()
%C_data = K, %C_exp = C for Galen Calibration

% Get C_data and C_exp
[C_data, C_exp, d] = get_Cdata_Cexp;

% Constants and matrices
n_frames = size(C_exp, 3);
n_markers = size(C_exp, 2);
C_data_2D = zeros(n_frames * n_markers, 3);
C_exp_2D = zeros(n_frames * n_markers, 3);

% Converting C_data and C_exp to 2D matrix
for k = 1:n_frames
    
    % Upper and lower bounds
    lower = (k - 1) * n_markers + 1;
    upper = lower + n_markers - 1;
    
    % Compile data
    C_data_2D(lower:upper, :) = C_data(:, :, k)';
    C_exp_2D(lower:upper, :) = C_exp(:, :, k)';
    
end

end